<!DOCTYPE html>
<html lang="en-US">
<head>
	<title>Monsters!</title>

	<meta charset="utf-8">

	<!-- Force latest available IE rendering engine and Chrome Frame (if installed) -->
	<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">

	<!-- Mobile Screen Resizing -->
	<meta name="viewport" content="width=device-width, initial-scale=1.0">
	<link href="https://fonts.googleapis.com/css?family=Cutive|Work+Sans" rel="stylesheet">

	<style type="text/css">
		/**
		 * Add box sizing to everything
		 * @link http://www.paulirish.com/2012/box-sizing-border-box-ftw/
		 */
		/* line 38, src/sass/components/_normalize.scss */
		*,
		*:before,
		*:after {
			box-sizing: border-box;
		}

		/**
		 * Layout
		 */
		body {
			font-family: 'Work Sans', sans-serif; sans-serif;
			font-size: 1.3rem;
			height: 100vh;
			flex-direction: column;
			display: flex;
			padding: 0;
			margin: 0
		}

		#app {
			display: grid;
			justify-items: center;
			grid-template-columns: repeat(3, 1fr);
			grid-auto-rows: 1fr;
			width: 100%;
			margin: auto;
			border-bottom: 1px solid #aaa;
			border-left: 1px solid #aaa;
		}

		@media (min-width: 30em) {
			#app {
				max-width: 20em;
			}
		}

		img {	width: auto;}
		.door {
			width: 100%;
			padding: 1rem;
			text-align: center;
			object-fit: contain;
			border-top: 1px solid #aaa;
		  border-right: 1px solid #aaa;
		}
		small {
			color: #808080;
			display: grid;
			grid-template-columns: repeat(5, 1fr)
		}
		small a {
			padding: .3rem;
		}
		h1, p { text-align: center; }
		.reload {margin: auto;}
		.text-small { font-size: 0.8em; }

		/**
		 * Buttons
		 */

		button {
			background-color: none;
			border: 0;
			font-size: inherit;
		}
		button:focus,
		button:active {
			background-color: #005580;
			border-color: #005580;
			color: #ffffff;
			text-decoration: none;
		}
		button:hover { cursor: pointer;}

	</style>
</head>
<body>

	<h1>Monsters!</h1>

	<p>Click on a door to find your monster friends. Avoid the sock!</p>

	<div id="app">Loading...</div>

	<div class="reload"><button id="reload">Play Again!</button></div>

	<footer class="padding-top">
		<p class="text-small text-muted">
			Icons by
			<small>
				<a href="https://thenounproject.com/term/door/311732/">Jamie Dickinson</a>
				<a href="https://thenounproject.com/term/monster/184225/">Nicky Knicky</a>
				<a href="https://thenounproject.com/term/monster/1510400/">Alvaro Cabrera</a>
				<a href="https://thenounproject.com/term/monster/28460/">Eliricon</a>
				<a href="https://thenounproject.com/term/monster/82823/">April Yang</a>
				<a href="https://thenounproject.com/term/monster/1062009/">tk66</a>
				<a href="https://thenounproject.com/term/monster/24990/">Alex WaZa</a>
				<a href="https://thenounproject.com/term/monster/37212/">Husein Aziz</a>
				<a href="https://thenounproject.com/term/socks/38451/">Yazmin Alanis</a>
			</small>
		</p>
	</footer>

	<script crossorigin="anonymous" src="https://polyfill.io/v3/polyfill.min.js?features=default"></script>
	<script>
	(function () {

		// Cache array of strings
		const monsters = [
			'sock!',
			'monster1.svg',
			'monster2.svg',
			'monster3.svg',
			'monster4.svg',
			'monster5.svg',
			'monster6.svg',
			'monster7.svg',
			'monster8.svg',
			'monster9.svg',
			'monster10.svg',
			'monster11.svg'
		];

		// Cache #app selector
		const app = document.querySelector('#app');

		/**
		* Randomly shuffle an array
		* https://stackoverflow.com/a/2450976/1293256
		* @param {Array} array The array to shuffle
		* @return {String} The first item in the shuffled array
		*/
		const shuffle = function (array) {

			let currentIndex = array.length;
			let temporaryValue, randomIndex;

				// While there remain elements to shuffle...
				while (0 !== currentIndex) {
				// Pick a remaining element...
				randomIndex = Math.floor(Math.random() * currentIndex);
				currentIndex -= 1;

				// And swap it with the current element.
				temporaryValue = array[currentIndex];
				array[currentIndex] = array[randomIndex];
				array[randomIndex] = temporaryValue;
			}
			return array;
		};

		// Shuffle monsters array
		// keep monsters as is just in case
		let shuffleMonsters = shuffle(monsters.slice()),
		html = [];

		shuffleMonsters.forEach(i => {
			html.push(
				`
					<button class="door" data-src="${i}"><img src="door.svg" /></button>
				`
			)
		})

		app.innerHTML = html.join('')

		// Remove doors on click
		document.addEventListener('click', (e) => {

			let sock = e.target.closest('[data-src="sock!"]')
			if (sock) {
				sock.innerHTML = 'Sock!'

				app.querySelectorAll('[data-src]:not([data-src="sock!"])').forEach((el) => {
					el.innerHTML = '<img src="'+ el.getAttribute('data-src') +'"/>'
				})
			}

			let src = e.target.closest('[data-src*="monster"]')
			if (src) {
				src.innerHTML = '<img src="'+ src.getAttribute('data-src') +'"/>'
			}

			// Start a new game
			if (e.target.matches('#reload')) {
					e.preventDefault()
					location.reload(true);
			}
		});


	})()
	</script>

</body>
</html>
